﻿/*
*   file
*   author: ronglin
*   create date: 2012.2.29
*/

(function ($, ctx) {

    // localization
    var txtRes = {
        btnTitle: 'image library',
        imgLibTitle: 'Media library',
        mediaLibraryUrl: '' // this url generated by server side
    };
    // localize text resource
    if (window.__localization) { $.extend(txtRes, __localization.editors_js.file_js); }

    var fileClass = function (config) {
        if (!this.className) { this.className = 'filejs'; }
        fileClass.superclass.constructor.call(this, config);
    };

    yardi.extend(fileClass, ctx.editors.textClass, {

        input: null, button: null,

        initialize: function () {
            var self = this;
            fileClass.superclass.initialize.call(this);
            this.button = this.editCon.children('.butn');
            this.button.click(function () {
                var lib = new yardi.imgLib({
                    title: txtRes.imgLibTitle,
                    width: 900, height: 500, styleEditing: true,
                    url: txtRes.mediaLibraryUrl + '&fileType=image',
                    OnSelect: function (url, w, h, alt) {
                        self.setValue('url("' + url + '")');
                        self.syncValue();
                    }
                });
                lib.show();
            }).hover(function () {
                $(this).addClass('hover');
            }, function () {
                $(this).removeClass('hover');
            });
        },

        buildHtml: function (html) {
            html.push('<div class="butn" title="' + txtRes.btnTitle + '"></div>');
            fileClass.superclass.buildHtml.call(this, html);
        }

    });

    // register
    ctx.editors.fileClass = fileClass;

} (jQuery, visualstyle));
